/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.party.controller;

import cn.hutool.core.lang.Assert;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import com.github.xiaoymin.knife4j.annotations.ApiOperationSupport;
import lombok.AllArgsConstructor;
import javax.validation.Valid;

import org.springblade.community.entity.Building;
import org.springblade.core.mp.support.Condition;
import org.springblade.core.mp.support.Query;
import org.springblade.core.secure.BladeUser;
import org.springblade.core.tool.api.R;
import org.springblade.core.tool.utils.Func;
import org.springblade.system.expand.feign.IConfClient;
import org.springblade.system.expand.util.QueryWrapperUtil;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.bind.annotation.RequestParam;
import com.baomidou.mybatisplus.core.metadata.IPage;
import org.springblade.party.entity.Meeting;
import org.springblade.party.vo.MeetingVO;
import org.springblade.party.wrapper.MeetingWrapper;
import org.springblade.party.service.IMeetingService;
import org.springblade.core.boot.ctrl.BladeController;

import java.util.Map;

/**
 * 会议列表表 控制器
 *
 * @author BladeX
 * @since 2021-04-19
 */
@RestController
@AllArgsConstructor
@RequestMapping("/meeting")
@Api(value = "会议列表表", tags = "会议列表表接口")
public class MeetingController extends BladeController {

	private final IMeetingService meetingService;
	private final IConfClient confClient;

	/**
	 * 详情
	 */
	@GetMapping("/detail")
	@ApiOperationSupport(order = 1)
	@ApiOperation(value = "详情", notes = "传入meeting")
	public R<MeetingVO> detail(Meeting meeting) {
		Meeting detail = meetingService.getOne(Condition.getQueryWrapper(meeting));
		return R.data(MeetingWrapper.build().entityVO(detail));
	}

	/**
	 * 分页 会议列表表
	 */
	@GetMapping("/list")
	@ApiOperationSupport(order = 2)
	@ApiOperation(value = "分页", notes = "传入meeting")
	public R<IPage<MeetingVO>> list(@RequestParam Map<String,Object> meeting, Query query) {
		Integer hitStatus = null;
		Integer notificationStatus = null;
		Integer classId = null;
		Integer meetingStatus = null;
		Long branchId = null;
		if(meeting.get("hitStatus") != null){
			hitStatus = Integer.parseInt(String.valueOf(meeting.get("hitStatus")));
			meeting.remove("hitStatus");
		}
		if(meeting.get("notificationStatus") != null){
			notificationStatus = Integer.parseInt(String.valueOf(meeting.get("notificationStatus")));
			meeting.remove("notificationStatus");
		}
		if(meeting.get("classId") != null){
			classId = Integer.parseInt(String.valueOf(meeting.get("classId")));
			meeting.remove("classId");
		}
		if(meeting.get("meetingStatus") != null){
			meetingStatus = Integer.parseInt(String.valueOf(meeting.get("meetingStatus")));
			meeting.remove("meetingStatus");
		}
		if(meeting.get("branchId") != null){
			branchId = Long.parseLong(String.valueOf(meeting.get("branchId")));
			meeting.remove("branchId");
		}
		LambdaQueryWrapper<Meeting> lambdaQueryWrapper = Condition.getQueryWrapper(meeting, Meeting.class).lambda();
		lambdaQueryWrapper.eq(hitStatus != null, Meeting::getHitStatus, hitStatus);
		lambdaQueryWrapper.eq(notificationStatus != null, Meeting::getNotificationStatus, notificationStatus);
		lambdaQueryWrapper.eq(classId != null, Meeting::getClassId, classId);
		lambdaQueryWrapper.eq(meetingStatus != null, Meeting::getMeetingStatus, meetingStatus);
		lambdaQueryWrapper.eq(branchId != null, Meeting::getBranchId, branchId);
		IPage<Meeting> pages = meetingService.page(Condition.getPage(query), lambdaQueryWrapper);
		return R.data(MeetingWrapper.build().pageVO(pages));
	}


	/**
	 * 自定义分页 会议列表表
	 */
	@GetMapping("/page")
	@ApiOperationSupport(order = 3)
	@ApiOperation(value = "分页", notes = "传入meeting")
	public R<IPage<MeetingVO>> page(MeetingVO meeting, Query query) {
		Assert.notNull(meeting.getBranchId(),"支部id不能为空");
		IPage<MeetingVO> pages = meetingService.selectMeetingPage(Condition.getPage(query), meeting);
		return R.data(pages);
	}

	/**
	 * 新增 会议列表表
	 */
	@PostMapping("/save")
	@ApiOperationSupport(order = 4)
	@ApiOperation(value = "新增", notes = "传入meeting")
	public R save(@Valid @RequestBody Meeting meeting) {
		return R.status(meetingService.save(meeting));
	}

	/**
	 * 修改 会议列表表
	 */
	@PostMapping("/update")
	@ApiOperationSupport(order = 5)
	@ApiOperation(value = "修改", notes = "传入meeting")
	public R update(@Valid @RequestBody Meeting meeting) {
		return R.status(meetingService.updateById(meeting));
	}

	/**
	 * 新增或修改 会议列表表
	 */
	@PostMapping("/submit")
	@ApiOperationSupport(order = 6)
	@ApiOperation(value = "新增或修改", notes = "传入meeting")
	public R submit(@Valid @RequestBody Meeting meeting) {
		meeting.setImg(confClient.removePrefix(meeting.getImg()));
		return R.status(meetingService.saveOrUpdate(meeting));
	}


	/**
	 * 删除 会议列表表
	 */
	@PostMapping("/remove")
	@ApiOperationSupport(order = 7)
	@ApiOperation(value = "逻辑删除", notes = "传入ids")
	public R remove(@ApiParam(value = "主键集合", required = true) @RequestParam String ids) {
		return R.status(meetingService.deleteLogic(Func.toLongList(ids)));
	}


}
